Hooks:PostHook( WeaponFactoryTweakData, "init", "massblaster_init", function(self)

	local custom_weapon_id = "wpn_fps_smg_mass"
	local stance_base_id = "wpn_fps_ass_m4"
	local uses_sights = {"wpn_fps_upg_o_specter","wpn_fps_upg_o_aimpoint","wpn_fps_upg_o_docter","wpn_fps_upg_o_eotech","wpn_fps_upg_o_t1micro","wpn_fps_upg_o_cmore","wpn_fps_upg_o_aimpoint_2","wpn_fps_upg_o_acog","wpn_fps_upg_o_eotech_xps","wpn_fps_upg_o_reflex","wpn_fps_upg_o_rx01","wpn_fps_upg_o_rx30","wpn_fps_upg_o_cs", "wpn_fps_upg_o_spot","wpn_fps_upg_o_xpsg33_magnifier", "wpn_fps_upg_o_sig","wpn_fps_upg_o_bmg","wpn_fps_upg_o_uh","wpn_fps_upg_o_fc1","wpn_fps_upg_o_tf90"}
	for _, sight_id in pairs(uses_sights) do
		if self.parts[sight_id].stance_mod[stance_base_id] then
			self.parts[sight_id].stance_mod[custom_weapon_id] = deep_clone(self.parts[sight_id].stance_mod[stance_base_id])
		else
			log("[ERROR] " .. custom_weapon_id .. " Missing stance_mod data for: " .. sight_id, stance_base_id)
		end
		--self.parts.wpn_fps_upg_mass_b_shroud.override[sight_id] = {a_obj = "a_o_shroud"}
	end
	
	for _, part_id in pairs(self.wpn_fps_smg_mass.uses_parts) do

		if self.parts[part_id].type == "gadget" then
			self.parts.wpn_fps_upg_mass_b_shroud.override[part_id] = {a_obj = "a_fl_shroud"}
			self.parts.wpn_fps_upg_mass_b_thrust.override[part_id] = {a_obj = "a_fl_shroud"}
		else
			-- literally nothing
		end
	end
		self.parts.wpn_fps_upg_mass_b_thrust.custom_stats = {
			optimal_range_mul = 1.25,
			far_falloff_mul = 1.25
		}
		self.parts.wpn_fps_upg_mass_b_thrust.override.wpn_fps_addon_ris = {a_obj = "a_fl_shroud"}
		self.parts.wpn_fps_upg_mass_b_shroud.override.wpn_fps_addon_ris = {a_obj = "a_fl_shroud"}
		self.parts.wpn_fps_upg_mass_poisondummy.custom_stats = {
			rays = 3,
			ignore_statistic = true, -- ?????????????
			armor_piercing_add = 1,
			can_shoot_through_enemy = false,
			can_shoot_through_shield = false, 
			can_shoot_through_wall = false,
			bullet_class = "PoisonBulletBase",
			dot_data = {
				type = "carls_epic_poison",
				custom_data = {}
			}
		}
		self.parts.wpn_fps_upg_mass_n_poison.override_weapon = {
			sounds = {
				fire = "mass_fire_bio",
				fire_single = "mass_fire_bio",
				use_fix = true
			}
		}
		self.parts.wpn_fps_upg_mass_firedummy.custom_stats = {
			rays = 3,
			ignore_statistic = true, -- ?????????????
			armor_piercing_add = 1,
			can_shoot_through_enemy = false,
			can_shoot_through_shield = true, 
			can_shoot_through_wall = false,
			hit_effect = "dragonsbreath",
			bullet_class = "FlameBulletBase",
			fire_dot_data = {
				dot_trigger_chance = "100",
				dot_damage = "10",
				dot_length = "3.1",
				dot_trigger_max_distance = "3000",
				dot_tick_period = "0.5"
			}
		}
		self.parts.wpn_fps_upg_mass_n_fire.override_weapon = {
			sounds = {
				fire = "mass_fire_incen",
				fire_single = "mass_fire_incen",
				use_fix = true
			}
		}
		self.parts.wpn_fps_upg_mass_stundummy.custom_stats = {
			rays = 3,
			-- ignore_statistic = true, -- ?????????????
			armor_piercing_add = 1,
			can_shoot_through_enemy = false,
			can_shoot_through_shield = false, 
			can_shoot_through_wall = false,
			bullet_class = "InstantElectricBulletBase"
		}
		self.parts.wpn_fps_upg_mass_n_stun.override_weapon = {
			sounds = {
				fire = "mass_fire_elec",
				fire_single = "mass_fire_elec",
				use_fix = true
			}
		}
		self.parts.wpn_fps_upg_mass_apdummy.custom_stats = {
			rays = 3,
			armor_piercing_add = 1,
			can_shoot_through_enemy = true,
			can_shoot_through_shield = false, 
			can_shoot_through_wall = false
		}
		self.parts.wpn_fps_upg_mass_n_ap.override_weapon = {
			sounds = {
				fire = "mass_fire_rad",
				fire_single = "mass_fire_rad",
				use_fix = true
			}
		}
	--[[
	self.parts.wpn_fps_upg_mk17_rec_upper_mk20.override.wpn_fps_ass_mk17_b_standard = {
		unit = "units/mods/weapons/wpn_fps_ass_mk17_pts/wpn_fps_upg_mk17_b_long",
		override = {
			wpn_fps_ass_mk17_b_dummy = {a_obj = "a_b_long"}
		}
	}
	self.parts.wpn_fps_upg_mk17_rec_upper_mk20.override.wpn_fps_upg_mk17_b_long = {
		unit = "units/mods/weapons/wpn_fps_ass_mk17_pts/wpn_fps_upg_mk17_b_long_mk20",
		override = {
			wpn_fps_ass_mk17_b_dummy = {a_obj = "a_b_verylong"}
		}
	}
	self.parts.wpn_fps_upg_mk17_rec_upper_mk20.override.wpn_fps_ass_mk17_o_front = {
		unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"
	}
	]]--
	
	-- custom part stuff goes here idk
	
	
end)